#
# Conditional build:
%bcond_with	openssl		# use OpenSSL instead of GnuTLS
%bcond_without	static_libs	# static libraries

Summary:	LibVNCServer - a for easy implementation of VNC/RDP server
Summary(pl.UTF-8):	LibVNCServer - biblioteka do łatwego implementowania serwera VNC/RDP
Name:		libvncserver
Version:	0.9.14
Release:	2
License:	GPL v2
Group:		Libraries
#Source0Download: https://github.com/LibVNC/libvncserver/releases
Source0:	https://github.com/LibVNC/libvncserver/archive/LibVNCServer-%{version}.tar.gz
# Source0-md5:	763da812ede855665efd40340b595234
URL:		https://github.com/LibVNC/libvncserver/
BuildRequires:	cmake >= 3.4
BuildRequires:	cyrus-sasl-devel >= 2
%{!?with_openssl:BuildRequires:	gnutls-devel >= 2.4.0}
BuildRequires:	libgcrypt-devel >= 1.4.0
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel
BuildRequires:	libva-devel >= 1.2.0
BuildRequires:	libva-x11-devel >= 1.2.0
BuildRequires:	lzo-devel
%{?with_openssl:BuildRequires:	openssl-devel}
BuildRequires:	pkgconfig
BuildRequires:	rpmbuild(macros) >= 1.605
BuildRequires:	sed >= 4.0
BuildRequires:	systemd-devel >= 1:209
BuildRequires:	xorg-lib-libX11-devel
BuildRequires:	xorg-lib-libXdamage-devel
BuildRequires:	xorg-lib-libXext-devel
BuildRequires:	xorg-lib-libXfixes-devel
BuildRequires:	xorg-lib-libXinerama-devel
BuildRequires:	xorg-lib-libXrandr-devel
BuildRequires:	xorg-lib-libXtst-devel
BuildRequires:	zlib-devel
# for noinst client_examples only
#BuildRequires:	SDL2-devel >= 2.0
#BuildRequires:	gtk+2-devel >= 2.0
# for vnc2mpg example
#BuildRequires:	ffmpeg-devel >= 3.1.0
%{!?with_openssl:Requires:	gnutls >= 2.4.0}
Requires:	libgcrypt >= 1.4.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
LibVNCServer makes writing a VNC server (or more correctly, a program
exporting a framebuffer via the Remote Frame Buffer protocol) easy.

It is based on OSXvnc, which in turn is based on the original Xvnc by
ORL, later AT&T research labs in UK.

It hides the programmer from the tedious task of managing clients and
compression schemata.

LibVNCServer was put together and is (actively ;-) maintained by
Johannes Schindelin <Johannes.Schindelin@gmx.de>.

%description -l pl.UTF-8
LibVNCServer ułatwia pisanie serwera VNC (lub, bardziej poprawnie,
programu eksportującego framebuffer poprzez protokół Remote Frame
Buffer).

Jest oparty na OSXvnc, który z kolei bazuje na oryginalnym Xvnc
napisanym przez ORL, a później AT&T.

Biblioteka ukrywa przed programistą nudne zadanie zarządzania
klientami i schematami kompresji.

LibVNCServer została poskładana i jest (aktywnie) utrzymywana przez
Johannesa Schindelina <Johannes.Schindelin@gmx.de>.

%package devel
Summary:	LibVNCServer header files
Summary(pl.UTF-8):	Pliki nagłówkowe LibVNCServer
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	cyrus-sasl-devel >= 2
%{!?with_openssl:Requires:	gnutls-devel >= 2.4.0}
Requires:	libgcrypt-devel >= 1.4.0
Requires:	libjpeg-devel
Requires:	libpng-devel
Requires:	lzo-devel
%{?with_openssl:Requires:	openssl-devel}
Requires:	zlib-devel

%description devel
LibVNCServer header files.

%description devel -l pl.UTF-8
Pliki nagłówkowe LibVNCServer.

%package static
Summary:	Static LibVNCServer libraries
Summary(pl.UTF-8):	Statyczne biblioteki LibVNCServer
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}

%description static
Static LibVNCServer libraries.

%description static -l pl.UTF-8
Statyczne biblioteki LibVNCServer.

%prep
%setup -q -n libvncserver-LibVNCServer-%{version}

%build
%if %{with static_libs}
install -d build-static
cd build-static
%cmake .. \
	-DBUILD_SHARED_LIBS=OFF \
	-DCMAKE_INSTALL_LIBDIR=%{_lib} \
	-DWITH_FFMPEG=OFF \
	%{?with_openssl:-DWITH_GNUTLS=OFF} \
	%{!?with_openssl:-DWITH_OPENSSL=OFF} \
	-DWITH_SDL=OFF

%{__make}
cd ..
%endif

install -d build
cd build
%cmake .. \
	-DCMAKE_INSTALL_LIBDIR=%{_lib} \
	-DWITH_FFMPEG=OFF \
	%{?with_openssl:-DWITH_GNUTLS=OFF} \
	%{!?with_openssl:-DWITH_OPENSSL=OFF} \
	-DWITH_SDL=OFF

%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%if %{with static_libs}
%{__make} -C build-static install \
	DESTDIR=$RPM_BUILD_ROOT
%endif

%{__make} -C build install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun	-p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc AUTHORS ChangeLog README.md
%attr(755,root,root) %{_libdir}/libvncclient.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libvncclient.so.1
%attr(755,root,root) %{_libdir}/libvncserver.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libvncserver.so.1

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libvncclient.so
%attr(755,root,root) %{_libdir}/libvncserver.so
%{_includedir}/rfb
%{_pkgconfigdir}/libvncclient.pc
%{_pkgconfigdir}/libvncserver.pc
%{_libdir}/cmake/LibVNCServer

%if %{with static_libs}
%files static
%defattr(644,root,root,755)
%{_libdir}/libvncclient.a
%{_libdir}/libvncserver.a
%endif
%changelog
* Fri Apr 28 2023 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/libvncserver.git;a=log;h=master

* Fri Apr 28 2023 Jakub Bogusz <qboosh@pld-linux.org> a4117d1
- fixed libdir in .pc file, added cmake BRs; release 2

* Mon Apr 10 2023 Jakub Bogusz <qboosh@pld-linux.org> 4946edd
- updated to 0.9.14

* Fri Nov 06 2020 Jan Palus <atler@pld-linux.org> ab6f528
- up to 0.9.13 (many security fixes)

* Tue Mar 17 2020 Jakub Bogusz <qboosh@pld-linux.org> 0233c8c
- updated to 0.9.12
- updated to 0.9.12, uses cmake now
- removed outdated linux,noLlibdir patch
- added libsuffix patch (fixes install libdir)

* Mon Jul 10 2017 Jakub Bogusz <qboosh@pld-linux.org> ecfb9b5
- added noLlibdir patch (avoid /usr/lib* in `libvncserver-config --libs` output); release 3

* Sat Apr 08 2017 Jan Rękorajski <baggins@pld-linux.org> ee5387a
- rebuild with gnutls 3.5
- release 2 (by relup.sh)

* Fri Mar 10 2017 Jakub Bogusz <qboosh@pld-linux.org> 32ed009
- updated to 0.9.11 (note: new sonames)
- removed obsolete format_string (applied) and outdated va patch (unmaintained h264 support has been dropped)

* Mon Mar 09 2015 Jan Rękorajski <baggins@pld-linux.org> a4fd024
- release 3 (by relup.sh)

* Sun Dec 07 2014 Jakub Bogusz <qboosh@pld-linux.org> 44dd1dd
- added va patch (update to libva 1.2+ API); release 2

* Sat Dec 06 2014 Jakub Bogusz <qboosh@pld-linux.org> 0857b62
- updated to 0.9.10 (fixes CVE-2014-4607 and some other security issues)
- updated format_string patch
- progs moved to vncterm.spec

* Tue Sep 30 2014 Elan Ruusamäe <glen@delfi.ee> cd65868
- no duplicate urls, drop epoch 0

* Tue Sep 30 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 4c2d050
- new urls; note 0.9.9 is FULL of security holes, TODO: add patches/use git snap

* Wed Dec 25 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> cdab933
- release 6 (by relup.sh)

* Sun Nov 03 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> aa808c9
- rel 5; build fixes added

* Sat Nov 02 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 2114264
- release 4 (by relup.sh)

* Tue Oct 29 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 5a9488e
- release 3 (by relup.sh)

* Tue Oct 29 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 07f877d
- release 2 (by relup.sh)

* Wed May 09 2012 Jakub Bogusz <qboosh@pld-linux.org> b025993
- BR: pkgconfig

* Wed May 09 2012 witekfl <witekfl@pld-linux.org> 66c7d09
- updated to 0.9.9
- updated the linux.patch
- LinuxVNC renamed to linuxvnc

* Wed May 09 2012 witekfl <witekfl@pld-linux.org> 002c00d
- updated for 0.9.9

